% File: example2.pl
% -----------------
%
% The second example from [1].
%
%
%

example('R1', 'all x le(x,x).').
example('R2', 'all x all y all z le(x,y) & le(y,z) -> le(x,z).').
example('R3', 'all x all y (le(x,y) | le(y,x)).').
example('R4', 'all x le(0,x).').
example('R5', 'all x all y add(x,y) = add(y,x).').
example('R6', 'all x all y all z add(add(x,y),z) = add(x,add(y,z)).').
example('R7', 'all x add(x,0) = x.').
example('R8', 'all x all y (-le(y,x) -> exists z (-le(z,x) & -le(y,z))).').
example('L4', 'all x le(1,x).').
example('L7', 'all x -le(add(x,1), x).').
example('L8', 'all a all y (le(x,y) & le(y,add(x,1)) -> (y=x) | (y=add(x,1))).').
example('X', '-(1=0).').



background(['R1', 'R2', 'R3', 'R5', 'R6']).
axioms(['R4', 'R7', 'R8', 'L4', 'L7', 'L8']).

blend('T30', [            'R8',       'L7', 'L8']).
blend('T50', [      'R7',             'L7'      ]).
blend('T51', [      'R7',       'L4', 'L7'      ]).
blend('T52', ['R4', 'R7',             'L7'      ]).
blend('T53', ['R4', 'R7',       'L4', 'L7'      ]).
blend('T10', [      'R7', 'R8',       'L7'      ]).
blend('T11', [      'R7', 'R8', 'L4', 'L7'      ]).
blend('T12', ['R4', 'R7', 'R8',       'L7'      ]).
blend('T13', ['R4', 'R7', 'R8', 'L4', 'L7'      ]).
blend('T62', ['R4', 'R7', 'R8',       'L7', 'L8']).
blend('T72', ['R4', 'R7',             'L7', 'L8']).

init([T30,T50]) :-
    blend('T30', T30),
    blend('T50', T50).




% Testsuite for example2. These tests require consistent/1 to exist,
% which is defined in "load.pl". To run the test suite (in SWI Prolog),
% type:
%
%   ?- [load].
%   ?- [example2].
%   ?- run_tests.
%

:- begin_tests(example2).

test(consistent_t30, [fail]) :-
        theory('T30', T), consistent(T).

test(consistent_t50) :-
        theory('T50', T), consistent(T).

test(consistent_t51, [fail]) :-
        theory('T51', T), consistent(T).

test(consistent_52) :-
        theory('T52', T), consistent(T).

test(consistent_53, [fail]) :-
        theory('T53', T), consistent(T).

test(consistent_10) :-
        theory('T10', T), consistent(T).

test(consistent_t11, [fail]) :-
        theory('T11', T), consistent(T).

test(consistent_t12) :-
        theory('T12', T), consistent(T).

test(consistent_t13, [fail]) :-
        theory('T13', T), consistent(T).

test(consistent_t62, [fail]) :-
        theory('T62', T), consistent(T).

test(consistent_t72) :-
        theory('T72', T), consistent(T).

:- end_tests(example2).

