:- begin_tests(prover9).
:- use_module(prover9).

examples(example1,
         ['-man(x) | mortal(x).',
          'man(george).',
          'mortal(george).']).

examples(example2,
         ['-man(x) | mortal(x).',
          'man(george).',
          '-mortal(george).']).


test(consistent) :-
    examples(example1, Theory),
    prover9_consistent(Theory).

test(inconsistent, [fail]) :-
    examples(example2, Theory),
    prover9_consistent(Theory).

test(consistent2) :-
    examples(example1, Theory),
    prover9_consistent(Theory, 2).

test(inconsistent2) :-
    examples(example2, Theory),
    prover9_consistent(Theory, 0).


test(pipe1) :-
    examples(example1, Theory),
    prover9:prover9_consistent_pipe(Theory, 2).

test(pipe2) :-
    examples(example2, Theory),
    prover9:prover9_consistent_pipe(Theory, 0).


test(file1) :-
    examples(example1, Theory),
    prover9:prover9_consistent_file(Theory, 2, 'test1').

test(file2) :-
    examples(example2, Theory),
    prover9:prover9_consistent_file(Theory, 0, 'test2').


:- end_tests(prover9).